haproxy搭建负载均衡
Posted
tags:
篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了haproxy搭建负载均衡相关的知识,希望对你有一定的参考价值。
拓扑:haproxy代理分发器:192.168.2.100
web1===192.168.2.131
web2===192.168.2.132
-
安装
[[email protected] ~]#yum -y install gcc gcc-c++ autoconf automake [[email protected] ~]# tar -zxf haproxy-1.8.0.tar.gz [[email protected] ~]# cd haproxy-1.8.0 [[email protected] haproxy-1.8.0]# uname -r 3.10.0-693.el7.x86_64 [[email protected] haproxy-1.8.0]# make TARGET=linux2628 PREFIX=/usr/local/haproxy [[email protected] haproxy-1.8.0]# make install PREFIX=/usr/local/haproxy
-
没有生成配置文件,手动添加haproxy配置文件
[[email protected] haproxy-1.8.0]# ls /usr/local/haproxy/ doc sbin share [[email protected] haproxy-1.8.0]# mkdir /usr/local/haproxy/etc
[[email protected] haproxy-1.8.0]# vim /usr/local/haproxy/etc/haproxy.cfg global log 127.0.0.1 local0 #log 127.0.0.1 local1 notice #log loghost local0 info maxconn 4096 chroot /usr/local/haproxy uid 99 #所属运行的用户uid,运行用户nobody gid 99 #所属运行的用户组 daemon #以后台形式运行haproxy nbproc 1 #启动1个haproxy实例。# #工作进程数量(CPU数量) ,实际工作中,应该设置成和CPU核心数一样。 这样可以发挥出最大的性能。 pidfile /usr/local/haproxy/run/haproxy.pid #将所有进程写入pid文件 #debug #调试错误时用 #quiet #安静 defaults log global log 127.0.0.1 local3 #日志文件的输出定向。产生的日志级别为local3. 系统中local1-7,用户自己定义 mode http #工作模式,所处理的类别,默认采用http模式,可配置成tcp作4层消息转发 option httplog #日志类别,记载http日志 option httpclose #每次请求完毕后主动关闭http通道,haproxy不支持keep-alive,只能模拟这种模式的实现 option dontlognull #不记录空连接,产生的日志 option forwardfor #如果后端服务器需要获得客户端真实ip需要配置的参数,可以从Http Header中获得客户端ip option redispatch #当serverid对应的服务器挂掉后,强制定向到其他健康服务器 retries 2 #2次连接失败就认为服务器不可用,主要通过后面的check检查 maxconn 2000 #最大连接数 balance roundrobin #负载均衡算法 stats uri /haproxy-stats #haproxy 监控页面的访问地址 # 可通过 http://localhost:80/haproxy-stats 访问 timeout connect 5000 #连接超时时间。 单位:ms 毫秒 timeout client 50000 #客户端连接超时时间 timeout server 50000 #服务器端连接超时时间 mode http option httpchk GET /index.html #健康检测#注意实际工作中测试时,应该下载某一个页面来进行测试,因此这个页面应该是个小页面,而不要用首页面。这里是每隔一秒检查一次页面。 frontend http #前端配置,http名称可自定义 bind 0.0.0.0:80 #发起http请求80端口,会被转发到设置的ip及端口 default_backend http_back #转发到后端 写上后端名称 backend http_back #后端配置,名称上下关联 server s1 192.168.2.131:80 weight 3 check #后端的主机 IP &权衡 server s2 192.168.2.132:80 weight 3 check #后端的主机 IP &权衡 #server node1 192.168.179.131:8081 check inter 2000 rise 3 fall 3 weight 30
# inter 2000 健康检查时间间隔2秒 # rise 3 检测多少次才认为是正常的 # fall 3 失败多少次才认为是不可用的 # weight 30 权重
关于负载均衡算法
#source 根据请求源IP
#static-rr 根据权重
#leastconn 最少连接者先处理
#uri 根据请求的uri
#url_param 根据请求的url参数
#rdp-cookie 据据cookie(name)来锁定并哈希每一次请求
#hdr(name) 根据HTTP请求头来锁定每一次HTTP请求
#roundrobin 轮询方式
3.复制haproxy启动脚本,到/etc/init.d下
[[email protected] haproxy-1.8.0]# cp /root/haproxy-1.8.0/examples/haproxy.init /etc/init.d/haproxy
[[email protected] haproxy-1.8.0]# chmod 755 /etc/init.d/haproxy
[[email protected] haproxy-1.8.0]# vim
vim vimdiff vimtutor
[[email protected] haproxy-1.8.0]# vim /etc/init.d/haproxy
#!/bin/sh
# chkconfig: - 85 15
# description: HA-Proxy server
# processname: haproxy
# config: /usr/local/haproxy/etc/haproxy.cfg #修改
# pidfile: /usr/local/haproxy/run/haproxy.pid #修改
# Source function library.
if [ -f /etc/init.d/functions ]; then
. /etc/init.d/functions
elif [ -f /etc/rc.d/init.d/functions ] ; then
. /etc/rc.d/init.d/functions
else
exit 0
fi
# Source networking configuration.
. /etc/sysconfig/network
# Check that networking is up.
[ "$NETWORKING" = "no" ] && exit 0
# This is our service name
BASENAME=`haproxy` #修改
BIN=/usr/sbin/haproxy #修改
CFG=/usr/local/haproxy/etc/haproxy.cfg
[ -f $CFG ] || exit 1
PIDFILE=/usr/local/haproxy/run/haproxy.pid #修改
LOCKFILE=/usr/local/haproxy/run/haproxy #修改
RETVAL=0
start() {
quiet_check
if [ $? -ne 0 ]; then
echo "Errors found in configuration file, check it with ‘$BASENAME check‘."
return 1
fi
echo -n "Starting $BASENAME: "
daemon $BIN -D -f $CFG -p $PIDFILE
RETVAL=$?
echo
[ $RETVAL -eq 0 ] && touch $LOCKFILE
return $RETVAL
}
stop() {
echo -n "Shutting down $BASENAME: "
killproc $BASENAME -USR1
RETVAL=$?
echo
[ $RETVAL -eq 0 ] && rm -f $LOCKFILE
[ $RETVAL -eq 0 ] && rm -f $PIDFILE
return $RETVAL
}
restart() {
quiet_check
if [ $? -ne 0 ]; then
echo "Errors found in configuration file, check it with ‘$BASENAME check‘."
return 1
fi
stop
start
}
reload() {
if ! [ -s $PIDFILE ]; then
return 0
fi
quiet_check
if [ $? -ne 0 ]; then
echo "Errors found in configuration file, check it with ‘$BASENAME check‘."
return 1
fi
$BIN -D -f $CFG -p $PIDFILE -sf $(cat $PIDFILE)
}
check() {
$BIN -c -q -V -f $CFG
}
quiet_check() {
$BIN -c -q -f $CFG
}
rhstatus() {
status $BASENAME
}
condrestart() {
[ -e $LOCKFILE ] && restart || :
}
# See how we were called.
case "$1" in
start)
start
;;
stop)
stop
;;
restart)
restart
;;
reload)
reload
;;
condrestart)
condrestart
;;
status)
rhstatus
;;
check)
check
;;
*)
echo $"Usage: $BASENAME {start|stop|restart|reload|condrestart|status|check}"
exit 1
esac
exit $?
4.复制haproxy文件到/usr/sbin下 (因为上面的haproxy.init启动脚本默认会去/usr/sbin下找)[[email protected] haproxy-1.8.0]#cp /usr/local/haproxy/sbin/haproxy /usr/sbin/
创建目录和权限
[[email protected] haproxy-1.8.0]# mkdir -p /usr/local/haproxy/run
[[email protected] haproxy-1.8.0]# chown nobody /usr/local/haproxy/ -R
配置日志收集
[[email protected] haproxy-1.8.0]# vim /etc/rsyslog.conf #打开以下两行的注释,不打开收不到日志
15 $ModLoad imudp #取消注释
16 $UDPServerRun 514 #取消注释
73 local7.* /var/log/boot.log #下面添加两行
74 local3.* /var/log/haproxy.log
75 local0.* /var/log/haproxy.log
[[email protected] haproxy-1.8.0]# systemctl restart rsyslog
5.启动和停止服务
<1>特殊启动方法1
[[email protected] haproxy-1.8.0]# /usr/local/haproxy/sbin/haproxy -f /usr/local/haproxy/etc/haproxy.cfg
[[email protected] haproxy-1.8.0]# ps -aux | grep haproxy
nobody 1763 0.0 0.0 14756 1088 ? Ss 16:03 0:00 /usr/sbin/haproxy -D -f /usr/local/haproxy/etc/haproxy.cfg -p /usr/local/haproxy/run/haproxy.pid
root 1768 0.0 0.0 112676 980 pts/0 S+ 16:04 0:00 grep --color=auto haproxy
[[email protected] haproxy-1.8.0]# netstat -antup | grep 80
tcp 0 0 0.0.0.0:80 0.0.0.0:* LISTEN 1763/haproxy
<2>停止服务[[email protected] haproxy-1.8.0]# killall haproxy#没有killall命令安装yum -y install psmisc
<3>HAproxy脚本启动方法2[[email protected] haproxy-1.8.0]# /etc/init.d/haproxy start 或 systemctl restart haproxy
<4>配置开机启动
[[email protected] haproxy-1.8.0]# chkconfig --add haproxy
[[email protected] haproxy-1.8.0]# chkconfig haproxy on
6.后端web测试页面配置
[[email protected] html]# yum install httpd php -y
[[email protected] html]# yum install httpd php -y
生成测试文件:
[[email protected] html]#echo 192.168.2.131 > /var/www/html/index.html
[[email protected] html]#echo 192.168.2.132 > /var/www/html/index.html
7.测试
http://192.168.2.100/haproxy-stats
以上是关于haproxy搭建负载均衡的主要内容,如果未能解决你的问题,请参考以下文章